#include <LPC214X.H>                        /* LPC214x definitions */
#include "type.h"
#include "usbreg.h"
#include "cmd.h"
#include "orion100.c"
#include "felix.c"
#include "i2c.c"		
#include "elves_mikro.c"
#include "atmega128.c"
#include "checkpins.c"
#include "SPI8Bits.c"
#include "PWM5_P0_21.c"
#define CRP1  0x12345678
#define CRP2  0x87654321
#define CRP3  0x43218765
#define NOCRP 0x11223344
#define AnswerToHost USB_WriteEP (0x81,&usb_out[0],64);
volatile unsigned int i2c_delay;
extern DWORD USB_WriteEP (DWORD EPNum, BYTE *pData, DWORD cnt) ;
//const unsigned crp __attribute__((section(".ARM.__at_0x1FC"))) = CRP2;

volatile int unsigned ReportFlag,io_cfg;
unsigned char usb_in[100];
unsigned char usb_out[100];				
extern void USB_ISR(void);
extern USB_Init(void);
extern USB_Connect(BOOL);

void delay(unsigned int a){
T0IR=1;
T0MR0=a;
T0TCR=3;T0TCR=1;
while((T0IR&1)==0);T0IR=1;
}
 unsigned int const SCL_PIN=1<<2,SDA_PIN=1<<3,RESET_PIN=1<<20;
const unsigned int SCK_PIN=1<<2,PDI_PIN=1<<23,PDO_PIN=1<<3,CS_PIN=1<<20;

void ClrUsbOut(void){
unsigned char a;
for(a=0;a<64;a++)usb_out[a]=0;
}
void p_pulse(unsigned int ActiveDelay,unsigned int NonActiveDelay)
{FIO0SET =RESET_PIN;delay(ActiveDelay);FIO0CLR =RESET_PIN;delay(NonActiveDelay);}//!!!3000 is very IMPORTANT for FELIX


void n_pulse(unsigned int ActiveDelay,unsigned int NonActiveDelay)
{FIO0CLR =RESET_PIN;delay(ActiveDelay);FIO0SET =RESET_PIN;delay(NonActiveDelay);}

unsigned int sclin(void){return(1&(FIO0PIN>>2));}//	/SCL_PIN				

unsigned int sdain(void){return(1&(FIO0PIN>>3));}// /SDA_PIN

void scl(unsigned int a){a&=1;
if(a==1) FIO0SET =SCL_PIN;else FIO0CLR =SCL_PIN;	
}
void sda(unsigned int a){a&=1;
if(a==1) FIO0SET =SDA_PIN;else FIO0CLR=SDA_PIN;
}
void PDO(unsigned int a){a&=1;if(a==1) FIO0SET =PDO_PIN;else FIO0CLR=PDO_PIN;
while((FIO0PIN&PDO_PIN)!=a<<3);}

void CS(unsigned int a){a&=1;if(a==1) FIO0SET =SCK_PIN;else FIO0CLR=SCK_PIN;
while((FIO0PIN&SCK_PIN)!=a<<2);}//SCK

void SCK(unsigned int a){a&=1;if(a==1) FIO0SET =CS_PIN;else FIO0CLR=CS_PIN;
while((FIO0PIN&CS_PIN)!=a<<20);
}//CS
unsigned int PDI(void){return(1&(FIO0PIN>>23));}

unsigned int GetDWord(BYTE *p){return ((*p<<24)|(*(p+1)<<16)|(*(p+2)<<8)|*(p+3));}
unsigned int GetWord(BYTE *p){return 65535&((*(p)<<8)|*(p+1));}

int main (void) {
 unsigned char dat;
 unsigned int err;
  T0TCR=0;T0CTCR=0;T0PR=50;T0MR0=10;T0MCR=5;//init timer for delay() function;
  
  USB_Init();       /* USB Initialization */
  USB_Connect(TRUE);
  ReportFlag=0;
 SCS=3;// Force IO as FastIO GPIO
 FIO0MASK=0;
 FIO1MASK=0;
 FIO0CLR =0x80000000;   // Connecting
 FIO0DIR =0x80000000|RESET_PIN|SCL_PIN|SDA_PIN;   // external 	  
 //PINSEL1 &= 0x3FFFFFFF; // R_pullup  to 3.3V
 
  PINSEL0=0;//&=~0xF0;//P0.2 & P0.3 -> GPIO
  PINSEL1=0;
  FIO0CLR =(1<<16|1<<21);////////////// mosfets lock 	&
  FIO0DIR|=(1<<16|1<<21|1<<2|1<<3);//// 	  & Set P0.2, P0.3 as Outputs

  sda(1);scl(1);

 while (1){


 while(DEV_INT_STAT==0);
   USB_ISR();
	 
	 if(ReportFlag!=0){
	   ReportFlag=0;
		 ClrUsbOut();
		 switch(usb_in[0]){				
		   case cmd_felix_read:{  
		           felix_read(GetWord(&usb_in[1]),usb_in[3],&usb_out[1]);
				   usb_out[0]=0;
				   AnswerToHost;}
           break;

		   case cmd_felix_write:{  		//  
		          felix_write(GetWord(&usb_in[1]),usb_in[3],&usb_in[4]);  // (usb_in[1]<<8)|usb_in[2]	 
				  //for(temp=0;temp<64;temp++) usb_out[temp]=usb_in[temp];
				  usb_out[0]=0;
				  AnswerToHost;}
           break;

		  case cmd_positive_pulse:{
		      p_pulse(GetDWord(&usb_in[1]),GetDWord(&usb_in[5]));
		      usb_out[0]=0;
			  AnswerToHost;}
          break;
		   
		  case cmd_negative_pulse:{
		      n_pulse(GetDWord(&usb_in[1]),GetDWord(&usb_in[5]));
		      usb_out[0]=0;
			  AnswerToHost;}
    	  break;
		   
		  case cmd_set_felix_ioconfig:{
		     PINSEL0=0;
             FIO0DIR=0x80000000|SCL_PIN|SDA_PIN|RESET_PIN;  
             sda(1);scl(1);
   			 usb_out[0]=0;
             AnswerToHost;}
		  break;		   												
		   
		  
		 case cmd_orion100_read:{  
		     orion100_read(GetWord(&usb_in[1]),usb_in[3],&usb_out[1]);
			 usb_out[0]=0;
			 AnswerToHost;}
         break;

		 case cmd_orion100_write:{  
		      orion100_write(GetWord(&usb_in[1]),usb_in[3],&usb_in[4]);
			  usb_out[0]=0;
			  AnswerToHost;}
         break;		   

		 case cmd_i2c_read:{  
		       err=i2c_read(usb_in[1],usb_in[2],&usb_out[1]);
			   usb_out[0]=err;
			   AnswerToHost;}
         break;		 
		 
		 case cmd_i2c_write:{  
		       err=i2c_write(usb_in[1],&usb_in[2]);
			   usb_out[0]=err;usb_out[1]=err>>8;
			   AnswerToHost;}
         break;		 
		 
		 case cmd_set_i2c_delay:{  		         
				 i2c_delay=GetDWord(&usb_in[1]);
				 usb_out[0]=0;
				 AnswerToHost;}
         break;		 
		 
		 case cmd_set_T0PR:{  		         
				 T0PR=GetDWord(&usb_in[1]);
				 usb_out[0]=0;
				 AnswerToHost;}
         break;		 

		 case cmd_elves_read:{  
		          err=elves_read(GetWord(&usb_in[1]),&usb_out[1]);
				  usb_out[0]=err;
				  AnswerToHost;}
         break;		 					  

		 case cmd_set_SPI_ioconfig:{  
 FIO0CLR =0x80000000|PDO_PIN|SCK_PIN;           // connecting 
 FIO0SET=RESET_PIN;
 FIO0DIR =0x80000000|RESET_PIN|PDO_PIN|SCK_PIN;   // external 	   1<<20 = activate MAX3222
				  usb_out[0]=0;
				  AnswerToHost;}
         break;	

		 case cmd_mega128_enter_pgmode:{  
		          pgm_ena(&usb_out[1]);
				  usb_out[0]=0;
				  AnswerToHost;}
         break;	
		 case cmd_mega128_read:{  
		          mega128_read(GetWord(&usb_in[1]),usb_in[3],&usb_out[1]);
				  usb_out[0]=0;
				  AnswerToHost;}
         break;
		 
		 case cmd_mega128_erase:{  
		          mega128_erase();
				  usb_out[0]=0;
				  AnswerToHost;}
         break;
         
		 case cmd_mega128_LoadInBuff:{  
		        mega128_LoadBuff(usb_in[1],usb_in[2],&usb_in[3]);
				  usb_out[0]=0;
				  AnswerToHost;}
         break;
		 case cmd_mega128_LoadInBuffAndPgmPage:{  
		 mega128_LoadBuff(usb_in[1],usb_in[2],&usb_in[5]);         
		 mega128_PgmPage(GetWord(&usb_in[3]));		  
				  usb_out[0]=0;
				  AnswerToHost;}
         break;		 
		 case cmd_DUMMY:{  
				  usb_out[0]=cmd_DUMMY;		  
				  AnswerToHost;}
         break;		 
					   
		 case cmd_check_pins:{  
			check_pins(&usb_out[1]);		  
		   	usb_out[0]=0;
		   AnswerToHost;}
         break;			 
		 
		 case cmd_SPI8BitsSendRecieve:{  
			CS(1);SCK(0);
			SPISendRecieve(&usb_in[2],&usb_out[1],usb_in[1]);		  
		   	usb_out[0]=0;
		   AnswerToHost;}
         break;	
		 		 
		 case cmd_GetSPI_Stat:{  
		if (FIO0PIN&CS_PIN)  usb_out[1]=1;else usb_out[1]=0;			  
		if (FIO0PIN&SCK_PIN) usb_out[2]=1;else usb_out[2]=0;
		if (FIO0PIN&PDO_PIN) usb_out[3]=1;else usb_out[3]=0;
		  usb_out[4]=PDI(); 	
			usb_out[0]=0;
		   AnswerToHost;}
         break;	

		 case cmd_SetCS_ONE:{  
		CS(1);	
			usb_out[0]=0;
		   AnswerToHost;}
         break;	

		 case cmd_SetCS_ZERO:{  
		CS(0);	
			usb_out[0]=0;
		   AnswerToHost;}
         break;	

		 case cmd_SetSCK_ONE:{  
		SCK(1);	
			usb_out[0]=0;
		   AnswerToHost;}
         break;	

		 case cmd_SetSCK_ZERO:{  
		SCK(0);	
			usb_out[0]=0;
		   AnswerToHost;}
         break;

		 case cmd_SetTDO_ONE:{  
		PDO(1);	
			usb_out[0]=0;
		   AnswerToHost;}
         break;
		 case cmd_SetTDO_ZERO:{  
		PDO(0);	
			usb_out[0]=0;
		   AnswerToHost;}
         break;

		 case cmd_SendByteSPI_No_CS_Control:{  
           	dat=usb_in[1];
		   PDO(dat>>7);SCK(1);delay(1);SCK(0);delay(1); 
           PDO(dat>>6);SCK(1);delay(1);SCK(0);delay(1); 
           PDO(dat>>5);SCK(1);delay(1);SCK(0);delay(1); 
           PDO(dat>>4);SCK(1);delay(1);SCK(0);delay(1); 
           PDO(dat>>3);SCK(1);delay(1);SCK(0);delay(1);	  
           PDO(dat>>2);SCK(1);delay(1);SCK(0);delay(1);  
           PDO(dat>>1);SCK(1);delay(1);SCK(0);delay(1);	  
           PDO(dat);   SCK(1);delay(1);SCK(0);delay(1);	
			usb_out[0]=0;
		   AnswerToHost;}
         break;

		 case cmd_mega128_GetFuses:{  
           mega128_GetFuses(&usb_out[1]);	
		   usb_out[0]=0;
		   AnswerToHost;}
         break;

		 case cmd_Freq_at_P0_21_ON:{  
           PWM_INIT (GetDWord(&usb_in[1]));	
		   usb_out[0]=0;
		   AnswerToHost;}
         break;

		 case cmd_Freq_at_P0_21_OFF	:{  
          PWM_Stop();	
		   usb_out[0]=0;
		   AnswerToHost;}
         break;
 
 	case cmd_mega128_GetID :{  
          mega128_GetID(&usb_out[1]);	
		   usb_out[0]=0;
		   AnswerToHost;}
         break;

 	case cmd_mega128_write_fuse_extended :{  
         mega128_WriteFuseExtended(usb_in[1]);	
		   usb_out[0]=0;
		   AnswerToHost;}
         break;

  	case cmd_mega128_write_fuse_high :{  
         mega128_WriteFuseHigh(usb_in[1]);	
		   usb_out[0]=0;
		   AnswerToHost;}
         break;

  	case cmd_mega128_write_fuse_low :{  
         mega128_WriteFuseLow(usb_in[1]);	
		   usb_out[0]=0;
		   AnswerToHost;}
         break;


	 default :
		 for(err=0;err<64;err++)usb_out[err]=234;
		 AnswerToHost;
		 break;
		 }//switch usb[0]     cmd_mega128_WriteFuses

	   }  //if
}	//while 1
}//main
